Description

When we get the list of known environments by using the puppetmaster API, the puppet parameter environmentpath is listed in

search_paths array.

Even if the module puppet_proxy in foreman-proxy request the puppet API, it does not use the search_paths array. And so foreman

can't search in the paths indicated in parameter environmentpath.

History

#1 - 02/03/2016 03:01 AM - Dominic Cleal

- Project changed from Foreman to Smart Proxy

- Category changed from Puppet integration to Puppet

#2 - 02/03/2016 04:47 AM - Fabien Combernous

I found a post in the puppet-dev mailling list that lets me support that the forman-proxy work well, and i missed an important detail about puppet.

At https://groups.google.com/forum/#!msg/puppet-dev/2QDi2ThnRJQ/EWrFJXa92i8J we can read :

If your 'environmentpath' setting contains multiple directories, then an environment will be matched from 

the first path directory it can be located in.  So environments found earlier in the path will shadow 

environments that are located later in the path.

So this explain why the second path was not displayed. I was using the same environment in the second path and so it was shadowed. And the two

following items lets me think this issue is not :

i read response['environments'].inject({}) do |envs, item| in foreman-proxy/modules/puppet_proxy/environment.rb

the API ouput have the following structure :

{

  "environments":

  {

    "production":

    {

      "settings":

      {

        "modulepath":["/my/path1/production/modules","/etc/puppet/environments/common","/etc/puppet/module

s","/usr/share/puppet/modules"],

        "config_version":"",

        "manifest":"/my/path1/production/manifests",

        "environment_timeout":180

      }

    },

    ...others envs ...

  "search_paths":["file:///my/path1","file:///my/path2","data:text/plain,internal"]

Sorry for the inconvenience.

05/17/2024 1/2

https://groups.google.com/forum/#!msg/puppet-dev/2QDi2ThnRJQ/EWrFJXa92i8J


#3 - 02/03/2016 04:51 AM - Dominic Cleal

- Status changed from New to Rejected
